function amap = generateAnisotropyMap(phiStep, thetaStep, phi_a, AHLshift)

np = 360/phiStep;
nt = 90/thetaStep;

[phi_v phi_i] = meshgrid(0:np-1,0:np-1);
phi_i = phi_i*phiStep;
phi_v = phi_v*phiStep;
if(max(AHLshift)>0 && AHLshift(1)~=AHLshift(2))
    shiftY = round(AHLshift(1)/phiStep);
    shiftX = round(AHLshift(2)/phiStep);
    phi_i = circshift(phi_i,[shiftY,shiftX]);
end;
if(max(AHLshift)>0 && AHLshift(1)==AHLshift(2))
    shiftY = round(AHLshift(1)/phiStep);
    shiftX = round(AHLshift(2)/phiStep);
    phi_i = circshift(phi_i,[shiftY,shiftX]);
    phi_v = circshift(phi_v,[shiftY,shiftX]);
end;

V = [];
for ti=0:nt-1
    for tv=0:nt-1
       theta_i = ones(np*np,1)*ti*thetaStep; 
       theta_v = ones(np*np,1)*tv*thetaStep; 
       phi_i = reshape(phi_i,np*np,1);
       phi_v = reshape(phi_v,np*np,1);
       V = [V;[theta_i theta_v phi_i phi_v]];
    end;
end;

V = V*(pi/180);

I = getAnisotropyWeight(V,phi_a);

amap = zeros(nt*np,nt*np);
C = zeros(np,np);
for ti=0:nt-1
    for tv=0:nt-1
        C = I(1,(ti*nt+tv)*np*np+1:(ti*nt+tv+1)*np*np);
        amap(ti*np+1:(ti+1)*np,tv*np+1:(tv+1)*np) = reshape(C',np,np);
    end;
end;

% figure(1);
% imshow((amap+1)/2);
% imshow(abs(amap));

