function err = rmse(BRDF1, BRDF2, compute_dE, DR)

% 1-relErr (MRE)
% 2-MSE
% 3-RMSE
% 4-PSNR 255lev
% 5-PSNR 1 lev
% 6-dE

% BRDF1 = BRDF1+eps*ones(size(BRDF1));

% relErr = sqrt(sum(sum(sum((BRDF1-BRDF2).^2)))/sum(sum(sum(BRDF1.^2))));
relErr =  sum(sum(sum( ((BRDF1-BRDF2)./BRDF1).^2 )))/(size(BRDF1,1)*size(BRDF1,2)*size(BRDF1,3)) ;
% fprintf('Error: %f%%\n', relErr*100);

valMSE = sum(sum(sum((BRDF1-BRDF2).^2)))/(size(BRDF1,1)*size(BRDF1,2)*size(BRDF1,3));
maxL = 2^8;
valPSNR = 10*log10(maxL^2/valMSE);
valMSE = sum(sum(sum((BRDF1/255-BRDF2/255).^2)))/(size(BRDF1,1)*size(BRDF1,2)*size(BRDF1,3));
valPSNR2 = 10*log10(DR^2/valMSE);

err(1,1) = relErr;
err(1,2) = valMSE;
err(1,3) = sqrt(valMSE);
err(1,4) = valPSNR;
err(1,5) = valPSNR2;

if (compute_dE)
    BRDF1 = BRDF_sRGB2Lab(BRDF1);
    BRDF2 = BRDF_sRGB2Lab(BRDF2);
    dE = sum(sum(sqrt((BRDF1(:,:,1)-BRDF2(:,:,1)).^2 +...
                      (BRDF1(:,:,2)-BRDF2(:,:,2)).^2 +...
                      (BRDF1(:,:,3)-BRDF2(:,:,3)).^2)))/(size(BRDF1,1)*size(BRDF1,2));
    err(1,6) = dE;
end

